## Ms Basic Connect Extensions service

Ms Basic Connect Extensions service — Support for the Ms Basic Connect Extensions service.

## Functions

void | mbim_pco_value_free ()
void | mbim_lte_attach_configuration_array_free ()
void | mbim_slot_array_free ()
void | mbim_provisioned_context_element_v2_array_free ()
void | mbim_cell_info_serving_gsm_free ()
void | mbim_cell_info_serving_umts_free ()
void | mbim_cell_info_serving_tdscdma_free ()
void | mbim_cell_info_serving_lte_free ()
void | mbim_cell_info_neighboring_gsm_array_free ()
void | mbim_cell_info_neighboring_umts_array_free ()
void | mbim_cell_info_neighboring_tdscdma_array_free ()
void | mbim_cell_info_neighboring_lte_array_free ()
void | mbim_cell_info_cdma_array_free ()
MbimMessage * | mbim_message_ms_basic_connect_extensions_pco_query_new ()
gboolean | mbim_message_ms_basic_connect_extensions_pco_response_parse ()
gboolean | mbim_message_ms_basic_connect_extensions_pco_notification_parse ()
MbimMessage * | mbim_message_ms_basic_connect_extensions_lte_attach_configuration_query_new ()
MbimMessage * | mbim_message_ms_basic_connect_extensions_lte_attach_configuration_set_new ()
gboolean | mbim_message_ms_basic_connect_extensions_lte_attach_configuration_response_parse ()
gboolean | mbim_message_ms_basic_connect_extensions_lte_attach_configuration_notification_parse ()
MbimMessage * | mbim_message_ms_basic_connect_extensions_lte_attach_info_query_new ()
gboolean | mbim_message_ms_basic_connect_extensions_lte_attach_info_response_parse ()
gboolean | mbim_message_ms_basic_connect_extensions_lte_attach_info_notification_parse ()
MbimMessage * | mbim_message_ms_basic_connect_extensions_sys_caps_query_new ()
gboolean | mbim_message_ms_basic_connect_extensions_sys_caps_response_parse ()
MbimMessage * | mbim_message_ms_basic_connect_extensions_slot_info_status_query_new ()
gboolean | mbim_message_ms_basic_connect_extensions_slot_info_status_response_parse ()
gboolean | mbim_message_ms_basic_connect_extensions_slot_info_status_notification_parse ()
MbimMessage * | mbim_message_ms_basic_connect_extensions_device_slot_mappings_query_new ()
MbimMessage * | mbim_message_ms_basic_connect_extensions_device_slot_mappings_set_new ()
gboolean | mbim_message_ms_basic_connect_extensions_device_slot_mappings_response_parse ()
MbimMessage * | mbim_message_ms_basic_connect_extensions_device_caps_query_new ()
gboolean | mbim_message_ms_basic_connect_extensions_device_caps_response_parse ()
MbimMessage * | mbim_message_ms_basic_connect_extensions_location_info_status_query_new ()
gboolean | mbim_message_ms_basic_connect_extensions_location_info_status_response_parse ()
gboolean | mbim_message_ms_basic_connect_extensions_location_info_status_notification_parse ()
MbimMessage * | mbim_message_ms_basic_connect_extensions_provisioned_contexts_query_new ()
MbimMessage * | mbim_message_ms_basic_connect_extensions_provisioned_contexts_set_new ()
gboolean | mbim_message_ms_basic_connect_extensions_provisioned_contexts_response_parse ()
gboolean | mbim_message_ms_basic_connect_extensions_provisioned_contexts_notification_parse ()
MbimMessage * | mbim_message_ms_basic_connect_extensions_base_stations_info_query_new ()
gboolean | mbim_message_ms_basic_connect_extensions_base_stations_info_response_parse ()
MbimMessage * | mbim_message_ms_basic_connect_extensions_device_reset_set_new ()
gboolean | mbim_message_ms_basic_connect_extensions_device_reset_response_parse ()

## Types and Values

| MbimPcoValue
| MbimLteAttachConfiguration
typedef | MbimLteAttachConfigurationArray
| MbimSlot
typedef | MbimSlotArray
| MbimProvisionedContextElementV2
typedef | MbimProvisionedContextElementV2Array
| MbimCellInfoServingGsm
| MbimCellInfoServingUmts
| MbimCellInfoServingTdscdma
| MbimCellInfoServingLte
| MbimCellInfoNeighboringGsm
typedef | MbimCellInfoNeighboringGsmArray
| MbimCellInfoNeighboringUmts
typedef | MbimCellInfoNeighboringUmtsArray
| MbimCellInfoNeighboringTdscdma
typedef | MbimCellInfoNeighboringTdscdmaArray
| MbimCellInfoNeighboringLte
typedef | MbimCellInfoNeighboringLteArray
| MbimCellInfoCdma
typedef | MbimCellInfoCdmaArray

## Description

This section implements support for requests, responses and notifications in the Ms Basic Connect Extensions service.

## Functions

### mbim_pco_value_free ()

    void
    mbim_pco_value_free (MbimPcoValue *var);

Frees the memory allocated for the MbimPcoValue.

#### Parameters

var | a MbimPcoValue. |

Since: 1.18

### mbim_lte_attach_configuration_array_free ()

    void
    mbim_lte_attach_configuration_array_free
                                   (MbimLteAttachConfigurationArray *array);

Frees the memory allocated for the array of MbimLteAttachConfiguration structs.

#### Parameters

array | a NULL terminated array of MbimLteAttachConfiguration structs. |

Since: 1.18

### mbim_slot_array_free ()

    void
    mbim_slot_array_free (MbimSlotArray *array);

Frees the memory allocated for the array of MbimSlot structs.

#### Parameters

array | a NULL terminated array of MbimSlot structs. |

Since: 1.26

### mbim_provisioned_context_element_v2_array_free ()

    void
    mbim_provisioned_context_element_v2_array_free
                                   (MbimProvisionedContextElementV2Array *array);

Frees the memory allocated for the array of MbimProvisionedContextElementV2 structs.

#### Parameters

array | a NULL terminated array of MbimProvisionedContextElementV2 structs. |

Since: 1.28

### mbim_cell_info_serving_gsm_free ()

    void
    mbim_cell_info_serving_gsm_free (MbimCellInfoServingGsm *var);

Frees the memory allocated for the MbimCellInfoServingGsm.

#### Parameters

var | a MbimCellInfoServingGsm. |

Since: 1.28

### mbim_cell_info_serving_umts_free ()

    void
    mbim_cell_info_serving_umts_free (MbimCellInfoServingUmts *var);

Frees the memory allocated for the MbimCellInfoServingUmts.

#### Parameters

var | a MbimCellInfoServingUmts. |

Since: 1.28

### mbim_cell_info_serving_tdscdma_free ()

    void
    mbim_cell_info_serving_tdscdma_free (MbimCellInfoServingTdscdma *var);

Frees the memory allocated for the MbimCellInfoServingTdscdma.

#### Parameters

var | a MbimCellInfoServingTdscdma. |

Since: 1.28

### mbim_cell_info_serving_lte_free ()

    void
    mbim_cell_info_serving_lte_free (MbimCellInfoServingLte *var);

Frees the memory allocated for the MbimCellInfoServingLte.

#### Parameters

var | a MbimCellInfoServingLte. |

Since: 1.28

### mbim_cell_info_neighboring_gsm_array_free ()

    void
    mbim_cell_info_neighboring_gsm_array_free
                                   (MbimCellInfoNeighboringGsmArray *array);

Frees the memory allocated for the array of MbimCellInfoNeighboringGsm structs.

#### Parameters

array | a NULL terminated array of MbimCellInfoNeighboringGsm structs. |

Since: 1.28

### mbim_cell_info_neighboring_umts_array_free ()

    void
    mbim_cell_info_neighboring_umts_array_free
                                   (MbimCellInfoNeighboringUmtsArray *array);

Frees the memory allocated for the array of MbimCellInfoNeighboringUmts structs.

#### Parameters

array | a NULL terminated array of MbimCellInfoNeighboringUmts structs. |

Since: 1.28

### mbim_cell_info_neighboring_tdscdma_array_free ()

    void
    mbim_cell_info_neighboring_tdscdma_array_free
                                   (MbimCellInfoNeighboringTdscdmaArray *array);

Frees the memory allocated for the array of MbimCellInfoNeighboringTdscdma structs.

#### Parameters

array | a NULL terminated array of MbimCellInfoNeighboringTdscdma structs. |

Since: 1.28

### mbim_cell_info_neighboring_lte_array_free ()

    void
    mbim_cell_info_neighboring_lte_array_free
                                   (MbimCellInfoNeighboringLteArray *array);

Frees the memory allocated for the array of MbimCellInfoNeighboringLte structs.

#### Parameters

array | a NULL terminated array of MbimCellInfoNeighboringLte structs. |

Since: 1.28

### mbim_cell_info_cdma_array_free ()

    void
    mbim_cell_info_cdma_array_free (MbimCellInfoCdmaArray *array);

Frees the memory allocated for the array of MbimCellInfoCdma structs.

#### Parameters

array | a NULL terminated array of MbimCellInfoCdma structs. |

Since: 1.28

### mbim_message_ms_basic_connect_extensions_pco_query_new ()

    MbimMessage *
    mbim_message_ms_basic_connect_extensions_pco_query_new
                                   (const MbimPcoValue *pco_value,
                                    GError **error);

Create a new request for the 'PCO' query command in the 'Ms Basic Connect Extensions' service.

#### Parameters

pco_value | the 'PcoValue' field, given as a MbimPcoValue. | [in]
error | return location for error or `NULL`. |

#### Returns

a newly allocated MbimMessage, which should be freed with `mbim_message_unref()`.

Since: 1.18

### mbim_message_ms_basic_connect_extensions_pco_response_parse ()

    gboolean
    mbim_message_ms_basic_connect_extensions_pco_response_parse
                                   (const MbimMessage *message,
                                    MbimPcoValue **out_pco_value,
                                    GError **error);

Parses and returns parameters of the 'PCO' response command in the 'Ms Basic Connect Extensions' service.

#### Parameters

message | the MbimMessage. |
out_pco_value | return location for a newly allocated MbimPcoValue, or `NULL` if the 'PcoValue' field is not needed. Free the returned value with `mbim_pco_value_free()`. | [out][optional][transfer full]
error | return location for error or `NULL`. |

#### Returns

`TRUE` if the message was correctly parsed, `FALSE` if `error` is set.

Since: 1.18

### mbim_message_ms_basic_connect_extensions_pco_notification_parse ()

    gboolean
    mbim_message_ms_basic_connect_extensions_pco_notification_parse
                                   (const MbimMessage *message,
                                    MbimPcoValue **out_pco_value,
                                    GError **error);

Parses and returns parameters of the 'PCO' notification command in the 'Ms Basic Connect Extensions' service.

#### Parameters

message | the MbimMessage. |
out_pco_value | return location for a newly allocated MbimPcoValue, or `NULL` if the 'PcoValue' field is not needed. Free the returned value with `mbim_pco_value_free()`. | [out][optional][transfer full]
error | return location for error or `NULL`. |

#### Returns

`TRUE` if the message was correctly parsed, `FALSE` if `error` is set.

Since: 1.18

### mbim_message_ms_basic_connect_extensions_lte_attach_configuration_query_new ()

    MbimMessage *
    mbim_message_ms_basic_connect_extensions_lte_attach_configuration_query_new
                                   (GError **error);

Create a new request for the 'Lte Attach Configuration' query command in the 'Ms Basic Connect Extensions' service.

#### Parameters

error | return location for error or `NULL`. |

#### Returns

a newly allocated MbimMessage, which should be freed with `mbim_message_unref()`.

Since: 1.18

### mbim_message_ms_basic_connect_extensions_lte_attach_configuration_set_new ()

    MbimMessage *
    mbim_message_ms_basic_connect_extensions_lte_attach_configuration_set_new
                                   (MbimLteAttachContextOperation operation,
                                    guint32 configuration_count,
                                    const MbimLteAttachConfiguration *const *configurations,
                                    GError **error);

Create a new request for the 'Lte Attach Configuration' set command in the 'Ms Basic Connect Extensions' service.

#### Parameters

operation | the 'Operation' field, given as a MbimLteAttachContextOperation. | [in]
configuration_count | the 'ConfigurationCount' field, given as a guint32. | [in]
configurations | the 'Configurations' field, given as an array of MbimLteAttachConfiguration items. | [in][array zero-terminated=1][element-type MbimLteAttachConfiguration]
error | return location for error or `NULL`. |

#### Returns

a newly allocated MbimMessage, which should be freed with `mbim_message_unref()`.

Since: 1.18

### mbim_message_ms_basic_connect_extensions_lte_attach_configuration_response_parse ()

    gboolean
    mbim_message_ms_basic_connect_extensions_lte_attach_configuration_response_parse
                                   (const MbimMessage *message,
                                    guint32 *out_configuration_count,
                                    MbimLteAttachConfigurationArray **out_configurations,
                                    GError **error);

Parses and returns parameters of the 'Lte Attach Configuration' response command in the 'Ms Basic Connect Extensions' service.

#### Parameters

message | the MbimMessage. |
out_configuration_count | return location for a guint32, or `NULL` if the 'ConfigurationCount' field is not needed. | [out][optional][transfer none]
out_configurations | return location for a newly allocated array of MbimLteAttachConfiguration items, or `NULL` if the 'Configurations' field is not needed. Free the returned value with `mbim_lte_attach_configuration_array_free()`. | [out][optional][transfer full][array zero-terminated=1][element-type MbimLteAttachConfiguration]
error | return location for error or `NULL`. |

#### Returns

`TRUE` if the message was correctly parsed, `FALSE` if `error` is set.

Since: 1.18

### mbim_message_ms_basic_connect_extensions_lte_attach_configuration_notification_parse ()

    gboolean
    mbim_message_ms_basic_connect_extensions_lte_attach_configuration_notification_parse
                                   (const MbimMessage *message,
                                    guint32 *out_configuration_count,
                                    MbimLteAttachConfigurationArray **out_configurations,
                                    GError **error);

Parses and returns parameters of the 'Lte Attach Configuration' notification command in the 'Ms Basic Connect Extensions' service.

#### Parameters

message | the MbimMessage. |
out_configuration_count | return location for a guint32, or `NULL` if the 'ConfigurationCount' field is not needed. | [out][optional][transfer none]
out_configurations | return location for a newly allocated array of MbimLteAttachConfiguration items, or `NULL` if the 'Configurations' field is not needed. Free the returned value with `mbim_lte_attach_configuration_array_free()`. | [out][optional][transfer full][array zero-terminated=1][element-type MbimLteAttachConfiguration]
error | return location for error or `NULL`. |

#### Returns

`TRUE` if the message was correctly parsed, `FALSE` if `error` is set.

Since: 1.18

### mbim_message_ms_basic_connect_extensions_lte_attach_info_query_new ()

    MbimMessage *
    mbim_message_ms_basic_connect_extensions_lte_attach_info_query_new
                                   (GError **error);

Create a new request for the 'Lte Attach Info' query command in the 'Ms Basic Connect Extensions' service.

#### Parameters

error | return location for error or `NULL`. |

#### Returns

a newly allocated MbimMessage, which should be freed with `mbim_message_unref()`.

Since: 1.26

### mbim_message_ms_basic_connect_extensions_lte_attach_info_response_parse ()

    gboolean
    mbim_message_ms_basic_connect_extensions_lte_attach_info_response_parse
                                   (const MbimMessage *message,
                                    MbimLteAttachState *out_lte_attach_state,
                                    MbimContextIpType *out_ip_type,
                                    gchar **out_access_string,
                                    gchar **out_user_name,
                                    gchar **out_password,
                                    MbimCompression *out_compression,
                                    MbimAuthProtocol *out_auth_protocol,
                                    GError **error);

Parses and returns parameters of the 'Lte Attach Info' response command in the 'Ms Basic Connect Extensions' service.

#### Parameters

message | the MbimMessage. |
out_lte_attach_state | return location for a MbimLteAttachState, or `NULL` if the 'LteAttachState' field is not needed. | [out][optional][transfer none]
out_ip_type | return location for a MbimContextIpType, or `NULL` if the 'IpType' field is not needed. | [out][optional][transfer none]
out_access_string | return location for a newly allocated string, or `NULL` if the 'AccessString' field is not needed. Free the returned value with `g_free()`. | [out][optional][transfer full]
out_user_name | return location for a newly allocated string, or `NULL` if the 'UserName' field is not needed. Free the returned value with `g_free()`. | [out][optional][transfer full]
out_password | return location for a newly allocated string, or `NULL` if the 'Password' field is not needed. Free the returned value with `g_free()`. | [out][optional][transfer full]
out_compression | return location for a MbimCompression, or `NULL` if the 'Compression' field is not needed. | [out][optional][transfer none]
out_auth_protocol | return location for a MbimAuthProtocol, or `NULL` if the 'AuthProtocol' field is not needed. | [out][optional][transfer none]
error | return location for error or `NULL`. |

#### Returns

`TRUE` if the message was correctly parsed, `FALSE` if `error` is set.

Since: 1.26

### mbim_message_ms_basic_connect_extensions_lte_attach_info_notification_parse ()

    gboolean
    mbim_message_ms_basic_connect_extensions_lte_attach_info_notification_parse
                                   (const MbimMessage *message,
                                    MbimLteAttachState *out_lte_attach_state,
                                    MbimContextIpType *out_ip_type,
                                    gchar **out_access_string,
                                    gchar **out_user_name,
                                    gchar **out_password,
                                    MbimCompression *out_compression,
                                    MbimAuthProtocol *out_auth_protocol,
                                    GError **error);

Parses and returns parameters of the 'Lte Attach Info' notification command in the 'Ms Basic Connect Extensions' service.

#### Parameters

message | the MbimMessage. |
out_lte_attach_state | return location for a MbimLteAttachState, or `NULL` if the 'LteAttachState' field is not needed. | [out][optional][transfer none]
out_ip_type | return location for a MbimContextIpType, or `NULL` if the 'IpType' field is not needed. | [out][optional][transfer none]
out_access_string | return location for a newly allocated string, or `NULL` if the 'AccessString' field is not needed. Free the returned value with `g_free()`. | [out][optional][transfer full]
out_user_name | return location for a newly allocated string, or `NULL` if the 'UserName' field is not needed. Free the returned value with `g_free()`. | [out][optional][transfer full]
out_password | return location for a newly allocated string, or `NULL` if the 'Password' field is not needed. Free the returned value with `g_free()`. | [out][optional][transfer full]
out_compression | return location for a MbimCompression, or `NULL` if the 'Compression' field is not needed. | [out][optional][transfer none]
out_auth_protocol | return location for a MbimAuthProtocol, or `NULL` if the 'AuthProtocol' field is not needed. | [out][optional][transfer none]
error | return location for error or `NULL`. |

#### Returns

`TRUE` if the message was correctly parsed, `FALSE` if `error` is set.

Since: 1.26

### mbim_message_ms_basic_connect_extensions_sys_caps_query_new ()

    MbimMessage *
    mbim_message_ms_basic_connect_extensions_sys_caps_query_new
                                   (GError **error);

Create a new request for the 'Sys Caps' query command in the 'Ms Basic Connect Extensions' service.

#### Parameters

error | return location for error or `NULL`. |

#### Returns

a newly allocated MbimMessage, which should be freed with `mbim_message_unref()`.

Since: 1.26

### mbim_message_ms_basic_connect_extensions_sys_caps_response_parse ()

    gboolean
    mbim_message_ms_basic_connect_extensions_sys_caps_response_parse
                                   (const MbimMessage *message,
                                    guint32 *out_number_of_executors,
                                    guint32 *out_number_of_slots,
                                    guint32 *out_concurrency,
                                    guint64 *out_modem_id,
                                    GError **error);

Parses and returns parameters of the 'Sys Caps' response command in the 'Ms Basic Connect Extensions' service.

#### Parameters

message | the MbimMessage. |
out_number_of_executors | return location for a guint32, or `NULL` if the 'NumberOfExecutors' field is not needed. | [out][optional][transfer none]
out_number_of_slots | return location for a guint32, or `NULL` if the 'NumberOfSlots' field is not needed. | [out][optional][transfer none]
out_concurrency | return location for a guint32, or `NULL` if the 'Concurrency' field is not needed. | [out][optional][transfer none]
out_modem_id | return location for a guint64, or `NULL` if the 'ModemId' field is not needed. | [out][optional][transfer none]
error | return location for error or `NULL`. |

#### Returns

`TRUE` if the message was correctly parsed, `FALSE` if `error` is set.

Since: 1.26

### mbim_message_ms_basic_connect_extensions_slot_info_status_query_new ()

    MbimMessage *
    mbim_message_ms_basic_connect_extensions_slot_info_status_query_new
                                   (guint32 slot_index,
                                    GError **error);

Create a new request for the 'Slot Info Status' query command in the 'Ms Basic Connect Extensions' service.

#### Parameters

slot_index | the 'SlotIndex' field, given as a guint32. | [in]
error | return location for error or `NULL`. |

#### Returns

a newly allocated MbimMessage, which should be freed with `mbim_message_unref()`.

Since: 1.26

### mbim_message_ms_basic_connect_extensions_slot_info_status_response_parse ()

    gboolean
    mbim_message_ms_basic_connect_extensions_slot_info_status_response_parse
                                   (const MbimMessage *message,
                                    guint32 *out_slot_index,
                                    MbimUiccSlotState *out_state,
                                    GError **error);

Parses and returns parameters of the 'Slot Info Status' response command in the 'Ms Basic Connect Extensions' service.

#### Parameters

message | the MbimMessage. |
out_slot_index | return location for a guint32, or `NULL` if the 'SlotIndex' field is not needed. | [out][optional][transfer none]
out_state | return location for a MbimUiccSlotState, or `NULL` if the 'State' field is not needed. | [out][optional][transfer none]
error | return location for error or `NULL`. |

#### Returns

`TRUE` if the message was correctly parsed, `FALSE` if `error` is set.

Since: 1.26

### mbim_message_ms_basic_connect_extensions_slot_info_status_notification_parse ()

    gboolean
    mbim_message_ms_basic_connect_extensions_slot_info_status_notification_parse
                                   (const MbimMessage *message,
                                    guint32 *out_slot_index,
                                    MbimUiccSlotState *out_state,
                                    GError **error);

Parses and returns parameters of the 'Slot Info Status' notification command in the 'Ms Basic Connect Extensions' service.

#### Parameters

message | the MbimMessage. |
out_slot_index | return location for a guint32, or `NULL` if the 'SlotIndex' field is not needed. | [out][optional][transfer none]
out_state | return location for a MbimUiccSlotState, or `NULL` if the 'State' field is not needed. | [out][optional][transfer none]
error | return location for error or `NULL`. |

#### Returns

`TRUE` if the message was correctly parsed, `FALSE` if `error` is set.

Since: 1.26

### mbim_message_ms_basic_connect_extensions_device_slot_mappings_query_new ()

    MbimMessage *
    mbim_message_ms_basic_connect_extensions_device_slot_mappings_query_new
                                   (GError **error);

Create a new request for the 'Device Slot Mappings' query command in the 'Ms Basic Connect Extensions' service.

#### Parameters

error | return location for error or `NULL`. |

#### Returns

a newly allocated MbimMessage, which should be freed with `mbim_message_unref()`.

Since: 1.26

### mbim_message_ms_basic_connect_extensions_device_slot_mappings_set_new ()

    MbimMessage *
    mbim_message_ms_basic_connect_extensions_device_slot_mappings_set_new
                                   (guint32 map_count,
                                    const MbimSlot *const *slot_map,
                                    GError **error);

Create a new request for the 'Device Slot Mappings' set command in the 'Ms Basic Connect Extensions' service.

#### Parameters

map_count | the 'MapCount' field, given as a guint32. | [in]
slot_map | the 'SlotMap' field, given as an array of MbimSlot items. | [in][array zero-terminated=1][element-type MbimSlot]
error | return location for error or `NULL`. |

#### Returns

a newly allocated MbimMessage, which should be freed with `mbim_message_unref()`.

Since: 1.26

### mbim_message_ms_basic_connect_extensions_device_slot_mappings_response_parse ()

    gboolean
    mbim_message_ms_basic_connect_extensions_device_slot_mappings_response_parse
                                   (const MbimMessage *message,
                                    guint32 *out_map_count,
                                    MbimSlotArray **out_slot_map,
                                    GError **error);

Parses and returns parameters of the 'Device Slot Mappings' response command in the 'Ms Basic Connect Extensions' service.

#### Parameters

message | the MbimMessage. |
out_map_count | return location for a guint32, or `NULL` if the 'MapCount' field is not needed. | [out][optional][transfer none]
out_slot_map | return location for a newly allocated array of MbimSlot items, or `NULL` if the 'SlotMap' field is not needed. Free the returned value with `mbim_slot_array_free()`. | [out][optional][transfer full][array zero-terminated=1][element-type MbimSlot]
error | return location for error or `NULL`. |

#### Returns

`TRUE` if the message was correctly parsed, `FALSE` if `error` is set.

Since: 1.26

### mbim_message_ms_basic_connect_extensions_device_caps_query_new ()

    MbimMessage *
    mbim_message_ms_basic_connect_extensions_device_caps_query_new
                                   (GError **error);

Create a new request for the 'Device Caps' query command in the 'Ms Basic Connect Extensions' service.

#### Parameters

error | return location for error or `NULL`. |

#### Returns

a newly allocated MbimMessage, which should be freed with `mbim_message_unref()`.

Since: 1.26

### mbim_message_ms_basic_connect_extensions_device_caps_response_parse ()

    gboolean
    mbim_message_ms_basic_connect_extensions_device_caps_response_parse
                                   (const MbimMessage *message,
                                    MbimDeviceType *out_device_type,
                                    MbimCellularClass *out_cellular_class,
                                    MbimVoiceClass *out_voice_class,
                                    MbimSimClass *out_sms_class,
                                    MbimDataClass *out_data_class,
                                    MbimSmsCaps *out_sms_caps,
                                    MbimCtrlCaps *out_control_caps,
                                    guint32 *out_max_sessions,
                                    gchar **out_custom_data_class,
                                    gchar **out_device_id,
                                    gchar **out_firmware_info,
                                    gchar **out_hardware_info,
                                    guint32 *out_executor_index,
                                    GError **error);

Parses and returns parameters of the 'Device Caps' response command in the 'Ms Basic Connect Extensions' service.

#### Parameters

message | the MbimMessage. |
out_device_type | return location for a MbimDeviceType, or `NULL` if the 'DeviceType' field is not needed. | [out][optional][transfer none]
out_cellular_class | return location for a MbimCellularClass, or `NULL` if the 'CellularClass' field is not needed. | [out][optional][transfer none]
out_voice_class | return location for a MbimVoiceClass, or `NULL` if the 'VoiceClass' field is not needed. | [out][optional][transfer none]
out_sms_class | return location for a MbimSimClass, or `NULL` if the 'SmsClass' field is not needed. | [out][optional][transfer none]
out_data_class | return location for a MbimDataClass, or `NULL` if the 'DataClass' field is not needed. | [out][optional][transfer none]
out_sms_caps | return location for a MbimSmsCaps, or `NULL` if the 'SmsCaps' field is not needed. | [out][optional][transfer none]
out_control_caps | return location for a MbimCtrlCaps, or `NULL` if the 'ControlCaps' field is not needed. | [out][optional][transfer none]
out_max_sessions | return location for a guint32, or `NULL` if the 'MaxSessions' field is not needed. | [out][optional][transfer none]
out_custom_data_class | return location for a newly allocated string, or `NULL` if the 'CustomDataClass' field is not needed. Free the returned value with `g_free()`. | [out][optional][transfer full]
out_device_id | return location for a newly allocated string, or `NULL` if the 'DeviceId' field is not needed. Free the returned value with `g_free()`. | [out][optional][transfer full]
out_firmware_info | return location for a newly allocated string, or `NULL` if the 'FirmwareInfo' field is not needed. Free the returned value with `g_free()`. | [out][optional][transfer full]
out_hardware_info | return location for a newly allocated string, or `NULL` if the 'HardwareInfo' field is not needed. Free the returned value with `g_free()`. | [out][optional][transfer full]
out_executor_index | return location for a guint32, or `NULL` if the 'ExecutorIndex' field is not needed. | [out][optional][transfer none]
error | return location for error or `NULL`. |

#### Returns

`TRUE` if the message was correctly parsed, `FALSE` if `error` is set.

Since: 1.26

### mbim_message_ms_basic_connect_extensions_location_info_status_query_new ()

    MbimMessage *
    mbim_message_ms_basic_connect_extensions_location_info_status_query_new
                                   (GError **error);

Create a new request for the 'Location Info Status' query command in the 'Ms Basic Connect Extensions' service.

#### Parameters

error | return location for error or `NULL`. |

#### Returns

a newly allocated MbimMessage, which should be freed with `mbim_message_unref()`.

Since: 1.28

### mbim_message_ms_basic_connect_extensions_location_info_status_response_parse ()

    gboolean
    mbim_message_ms_basic_connect_extensions_location_info_status_response_parse
                                   (const MbimMessage *message,
                                    guint32 *out_location_area_code,
                                    guint32 *out_tracking_area_code,
                                    guint32 *out_cell_id,
                                    GError **error);

Parses and returns parameters of the 'Location Info Status' response command in the 'Ms Basic Connect Extensions' service.

#### Parameters

message | the MbimMessage. |
out_location_area_code | return location for a guint32, or `NULL` if the 'LocationAreaCode' field is not needed. | [out][optional][transfer none]
out_tracking_area_code | return location for a guint32, or `NULL` if the 'TrackingAreaCode' field is not needed. | [out][optional][transfer none]
out_cell_id | return location for a guint32, or `NULL` if the 'CellID' field is not needed. | [out][optional][transfer none]
error | return location for error or `NULL`. |

#### Returns

`TRUE` if the message was correctly parsed, `FALSE` if `error` is set.

Since: 1.28

### mbim_message_ms_basic_connect_extensions_location_info_status_notification_parse ()

    gboolean
    mbim_message_ms_basic_connect_extensions_location_info_status_notification_parse
                                   (const MbimMessage *message,
                                    guint32 *out_location_area_code,
                                    guint32 *out_tracking_area_code,
                                    guint32 *out_cell_id,
                                    GError **error);

Parses and returns parameters of the 'Location Info Status' notification command in the 'Ms Basic Connect Extensions' service.

#### Parameters

message | the MbimMessage. |
out_location_area_code | return location for a guint32, or `NULL` if the 'LocationAreaCode' field is not needed. | [out][optional][transfer none]
out_tracking_area_code | return location for a guint32, or `NULL` if the 'TrackingAreaCode' field is not needed. | [out][optional][transfer none]
out_cell_id | return location for a guint32, or `NULL` if the 'CellID' field is not needed. | [out][optional][transfer none]
error | return location for error or `NULL`. |

#### Returns

`TRUE` if the message was correctly parsed, `FALSE` if `error` is set.

Since: 1.28

### mbim_message_ms_basic_connect_extensions_provisioned_contexts_query_new ()

    MbimMessage *
    mbim_message_ms_basic_connect_extensions_provisioned_contexts_query_new
                                   (GError **error);

Create a new request for the 'Provisioned Contexts' query command in the 'Ms Basic Connect Extensions' service.

#### Parameters

error | return location for error or `NULL`. |

#### Returns

a newly allocated MbimMessage, which should be freed with `mbim_message_unref()`.

Since: 1.28

### mbim_message_ms_basic_connect_extensions_provisioned_contexts_set_new ()

    MbimMessage *
    mbim_message_ms_basic_connect_extensions_provisioned_contexts_set_new
                                   (MbimContextOperation operation,
                                    const MbimUuid *context_type,
                                    MbimContextIpType ip_type,
                                    MbimContextState state,
                                    MbimContextRoamingControl roaming,
                                    MbimContextMediaType media_type,
                                    MbimContextSource source,
                                    const gchar *access_string,
                                    const gchar *user_name,
                                    const gchar *password,
                                    MbimCompression compression,
                                    MbimAuthProtocol auth_protocol,
                                    GError **error);

Create a new request for the 'Provisioned Contexts' set command in the 'Ms Basic Connect Extensions' service.

#### Parameters

operation | the 'Operation' field, given as a MbimContextOperation. | [in]
context_type | the 'ContextType' field, given as a MbimUuid. | [in]
ip_type | the 'IpType' field, given as a MbimContextIpType. | [in]
state | the 'State' field, given as a MbimContextState. | [in]
roaming | the 'Roaming' field, given as a MbimContextRoamingControl. | [in]
media_type | the 'MediaType' field, given as a MbimContextMediaType. | [in]
source | the 'Source' field, given as a MbimContextSource. | [in]
access_string | the 'AccessString' field, given as a string. | [in]
user_name | the 'UserName' field, given as a string. | [in]
password | the 'Password' field, given as a string. | [in]
compression | the 'Compression' field, given as a MbimCompression. | [in]
auth_protocol | the 'AuthProtocol' field, given as a MbimAuthProtocol. | [in]
error | return location for error or `NULL`. |

#### Returns

a newly allocated MbimMessage, which should be freed with `mbim_message_unref()`.

Since: 1.28

### mbim_message_ms_basic_connect_extensions_provisioned_contexts_response_parse ()

    gboolean
    mbim_message_ms_basic_connect_extensions_provisioned_contexts_response_parse
                                   (const MbimMessage *message,
                                    guint32 *out_provisioned_contexts_count,
                                    MbimProvisionedContextElementV2Array **out_provisioned_contexts,
                                    GError **error);

Parses and returns parameters of the 'Provisioned Contexts' response command in the 'Ms Basic Connect Extensions' service.

#### Parameters

message | the MbimMessage. |
out_provisioned_contexts_count | return location for a guint32, or `NULL` if the 'ProvisionedContextsCount' field is not needed. | [out][optional][transfer none]
out_provisioned_contexts | return location for a newly allocated array of MbimProvisionedContextElementV2 items, or `NULL` if the 'ProvisionedContexts' field is not needed. Free the returned value with `mbim_provisioned_context_element_v2_array_free()`. | [out][optional][transfer full][array zero-terminated=1][element-type MbimProvisionedContextElementV2]
error | return location for error or `NULL`. |

#### Returns

`TRUE` if the message was correctly parsed, `FALSE` if `error` is set.

Since: 1.28

### mbim_message_ms_basic_connect_extensions_provisioned_contexts_notification_parse ()

    gboolean
    mbim_message_ms_basic_connect_extensions_provisioned_contexts_notification_parse
                                   (const MbimMessage *message,
                                    guint32 *out_provisioned_contexts_count,
                                    MbimProvisionedContextElementV2Array **out_provisioned_contexts,
                                    GError **error);

Parses and returns parameters of the 'Provisioned Contexts' notification command in the 'Ms Basic Connect Extensions' service.

#### Parameters

message | the MbimMessage. |
out_provisioned_contexts_count | return location for a guint32, or `NULL` if the 'ProvisionedContextsCount' field is not needed. | [out][optional][transfer none]
out_provisioned_contexts | return location for a newly allocated array of MbimProvisionedContextElementV2 items, or `NULL` if the 'ProvisionedContexts' field is not needed. Free the returned value with `mbim_provisioned_context_element_v2_array_free()`. | [out][optional][transfer full][array zero-terminated=1][element-type MbimProvisionedContextElementV2]
error | return location for error or `NULL`. |

#### Returns

`TRUE` if the message was correctly parsed, `FALSE` if `error` is set.

Since: 1.28

### mbim_message_ms_basic_connect_extensions_base_stations_info_query_new ()

    MbimMessage *
    mbim_message_ms_basic_connect_extensions_base_stations_info_query_new
                                   (guint32 max_gsm_count,
                                    guint32 max_umts_count,
                                    guint32 max_tdscdma_count,
                                    guint32 max_lte_count,
                                    guint32 max_cdma_count,
                                    GError **error);

Create a new request for the 'Base Stations Info' query command in the 'Ms Basic Connect Extensions' service.

#### Parameters

max_gsm_count | the 'MaxGsmCount' field, given as a guint32. | [in]
max_umts_count | the 'MaxUmtsCount' field, given as a guint32. | [in]
max_tdscdma_count | the 'MaxTdscdmaCount' field, given as a guint32. | [in]
max_lte_count | the 'MaxLteCount' field, given as a guint32. | [in]
max_cdma_count | the 'MaxCdmaCount' field, given as a guint32. | [in]
error | return location for error or `NULL`. |

#### Returns

a newly allocated MbimMessage, which should be freed with `mbim_message_unref()`.

Since: 1.28

### mbim_message_ms_basic_connect_extensions_base_stations_info_response_parse ()

    gboolean
    mbim_message_ms_basic_connect_extensions_base_stations_info_response_parse
                                   (const MbimMessage *message,
                                    MbimDataClass *out_system_type,
                                    MbimCellInfoServingGsm **out_gsm_serving_cell,
                                    MbimCellInfoServingUmts **out_umts_serving_cell,
                                    MbimCellInfoServingTdscdma **out_tdscdma_serving_cell,
                                    MbimCellInfoServingLte **out_lte_serving_cell,
                                    guint32 *out_gsm_neighboring_cells_count,
                                    MbimCellInfoNeighboringGsmArray **out_gsm_neighboring_cells,
                                    guint32 *out_umts_neighboring_cells_count,
                                    MbimCellInfoNeighboringUmtsArray **out_umts_neighboring_cells,
                                    guint32 *out_tdscdma_neighboring_cells_count,
                                    MbimCellInfoNeighboringTdscdmaArray **out_tdscdma_neighboring_cells,
                                    guint32 *out_lte_neighboring_cells_count,
                                    MbimCellInfoNeighboringLteArray **out_lte_neighboring_cells,
                                    guint32 *out_cdma_cells_count,
                                    MbimCellInfoCdmaArray **out_cdma_cells,
                                    GError **error);

Parses and returns parameters of the 'Base Stations Info' response command in the 'Ms Basic Connect Extensions' service.

#### Parameters

message | the MbimMessage. |
out_system_type | return location for a MbimDataClass, or `NULL` if the 'SystemType' field is not needed. | [out][optional][transfer none]
out_gsm_serving_cell | return location for a newly allocated MbimCellInfoServingGsm, or `NULL` if the 'GsmServingCell' field is not needed. The availability of this field is not always guaranteed, and therefore `NULL` may be given as a valid output. Free the returned value with `mbim_cell_info_serving_gsm_free()`. | [out][optional][nullable][transfer full]
out_umts_serving_cell | return location for a newly allocated MbimCellInfoServingUmts, or `NULL` if the 'UmtsServingCell' field is not needed. The availability of this field is not always guaranteed, and therefore `NULL` may be given as a valid output. Free the returned value with `mbim_cell_info_serving_umts_free()`. | [out][optional][nullable][transfer full]
out_tdscdma_serving_cell | return location for a newly allocated MbimCellInfoServingTdscdma, or `NULL` if the 'TdscdmaServingCell' field is not needed. The availability of this field is not always guaranteed, and therefore `NULL` may be given as a valid output. Free the returned value with `mbim_cell_info_serving_tdscdma_free()`. | [out][optional][nullable][transfer full]
out_lte_serving_cell | return location for a newly allocated MbimCellInfoServingLte, or `NULL` if the 'LteServingCell' field is not needed. The availability of this field is not always guaranteed, and therefore `NULL` may be given as a valid output. Free the returned value with `mbim_cell_info_serving_lte_free()`. | [out][optional][nullable][transfer full]
out_gsm_neighboring_cells_count | return location for a guint32, or `NULL` if the field is not needed. | [out][optional][transfer none]

out_gsm_neighboring_cells

return location for a newly allocated array of MbimCellInfoNeighboringGsm items, or `NULL` if the 'GsmNeighboringCells' field is not needed. The availability of this field is not always guaranteed, and therefore `NULL` may be given as a valid output. Free the returned value with `mbim_cell_info_neighboring_gsm_array_free()`.

[out][optional][nullable][transfer full][array zero-terminated=1][element-type MbimCellInfoNeighboringGsm]

out_umts_neighboring_cells_count | return location for a guint32, or `NULL` if the field is not needed. | [out][optional][transfer none]

out_umts_neighboring_cells

return location for a newly allocated array of MbimCellInfoNeighboringUmts items, or `NULL` if the 'UmtsNeighboringCells' field is not needed. The availability of this field is not always guaranteed, and therefore `NULL` may be given as a valid output. Free the returned value with `mbim_cell_info_neighboring_umts_array_free()`.

[out][optional][nullable][transfer full][array zero-terminated=1][element-type MbimCellInfoNeighboringUmts]

out_tdscdma_neighboring_cells_count | return location for a guint32, or `NULL` if the field is not needed. | [out][optional][transfer none]

out_tdscdma_neighboring_cells

return location for a newly allocated array of MbimCellInfoNeighboringTdscdma items, or `NULL` if the 'TdscdmaNeighboringCells' field is not needed. The availability of this field is not always guaranteed, and therefore `NULL` may be given as a valid output. Free the returned value with `mbim_cell_info_neighboring_tdscdma_array_free()`.

[out][optional][nullable][transfer full][array zero-terminated=1][element-type MbimCellInfoNeighboringTdscdma]

out_lte_neighboring_cells_count | return location for a guint32, or `NULL` if the field is not needed. | [out][optional][transfer none]

out_lte_neighboring_cells

return location for a newly allocated array of MbimCellInfoNeighboringLte items, or `NULL` if the 'LteNeighboringCells' field is not needed. The availability of this field is not always guaranteed, and therefore `NULL` may be given as a valid output. Free the returned value with `mbim_cell_info_neighboring_lte_array_free()`.

[out][optional][nullable][transfer full][array zero-terminated=1][element-type MbimCellInfoNeighboringLte]

out_cdma_cells_count | return location for a guint32, or `NULL` if the field is not needed. | [out][optional][transfer none]

out_cdma_cells

return location for a newly allocated array of MbimCellInfoCdma items, or `NULL` if the 'CdmaCells' field is not needed. The availability of this field is not always guaranteed, and therefore `NULL` may be given as a valid output. Free the returned value with `mbim_cell_info_cdma_array_free()`.

[out][optional][nullable][transfer full][array zero-terminated=1][element-type MbimCellInfoCdma]

error | return location for error or `NULL`. |

#### Returns

`TRUE` if the message was correctly parsed, `FALSE` if `error` is set.

Since: 1.28

### mbim_message_ms_basic_connect_extensions_device_reset_set_new ()

    MbimMessage *
    mbim_message_ms_basic_connect_extensions_device_reset_set_new
                                   (GError **error);

Create a new request for the 'Device Reset' set command in the 'Ms Basic Connect Extensions' service.

#### Parameters

error | return location for error or `NULL`. |

#### Returns

a newly allocated MbimMessage, which should be freed with `mbim_message_unref()`.

Since: 1.30

### mbim_message_ms_basic_connect_extensions_device_reset_response_parse ()

    gboolean
    mbim_message_ms_basic_connect_extensions_device_reset_response_parse
                                   (const MbimMessage *message,
                                    GError **error);

Parses and returns parameters of the 'Device Reset' response command in the 'Ms Basic Connect Extensions' service.

#### Parameters

message | the MbimMessage. |
error | return location for error or `NULL`. |

#### Returns

`TRUE` if the message was correctly parsed, `FALSE` if `error` is set.

Since: 1.30

## Types and Values

### MbimPcoValue

    typedef struct {
        guint32 session_id;
        guint32 pco_data_size;
        guint32 pco_data_type;
        guint8 *pco_data_buffer;
    } MbimPcoValue;

A MbimPcoValue element.

#### Members

guint32 `session_id`; | a guint32. |
guint32 `pco_data_size`; | a guint32. |
guint32 `pco_data_type`; | a MbimPcoType given as a guint32. |
guint8 *`pco_data_buffer`; | an array of guint8 values. |

Since: 1.18

### MbimLteAttachConfiguration

    typedef struct {
        guint32 ip_type;
        guint32 roaming;
        guint32 source;
        gchar *access_string;
        gchar *user_name;
        gchar *password;
        guint32 compression;
        guint32 auth_protocol;
    } MbimLteAttachConfiguration;

A MbimLteAttachConfiguration element.

#### Members

guint32 `ip_type`; | a MbimContextIpType given as a guint32. |
guint32 `roaming`; | a MbimLteAttachContextRoamingControl given as a guint32. |
guint32 `source`; | a MbimContextSource given as a guint32. |
gchar *`access_string`; | a string. |
gchar *`user_name`; | a string. |
gchar *`password`; | a string. |
guint32 `compression`; | a MbimCompression given as a guint32. |
guint32 `auth_protocol`; | a MbimAuthProtocol given as a guint32. |

Since: 1.18

### MbimLteAttachConfigurationArray

    typedef MbimLteAttachConfiguration *MbimLteAttachConfigurationArray;

A NULL-terminated array of MbimLteAttachConfiguration elements.

Since: 1.24

### MbimSlot

    typedef struct {
        guint32 slot;
    } MbimSlot;

A MbimSlot element.

#### Members

guint32 `slot`; | a guint32. |

Since: 1.26

### MbimSlotArray

    typedef MbimSlot *MbimSlotArray;

A NULL-terminated array of MbimSlot elements.

Since: 1.26

### MbimProvisionedContextElementV2

    typedef struct {
        guint32 context_id;
        MbimUuid context_type;
        guint32 ip_type;
        guint32 state;
        guint32 roaming;
        guint32 media_type;
        guint32 source;
        gchar *access_string;
        gchar *user_name;
        gchar *password;
        guint32 compression;
        guint32 auth_protocol;
    } MbimProvisionedContextElementV2;

A MbimProvisionedContextElementV2 element.

#### Members

guint32 `context_id`; | a guint32. |
MbimUuid `context_type`; | a MbimUuid. |
guint32 `ip_type`; | a MbimContextIpType given as a guint32. |
guint32 `state`; | a MbimContextState given as a guint32. |
guint32 `roaming`; | a MbimContextRoamingControl given as a guint32. |
guint32 `media_type`; | a MbimContextMediaType given as a guint32. |
guint32 `source`; | a MbimContextSource given as a guint32. |
gchar *`access_string`; | a string. |
gchar *`user_name`; | a string. |
gchar *`password`; | a string. |
guint32 `compression`; | a MbimCompression given as a guint32. |
guint32 `auth_protocol`; | a MbimAuthProtocol given as a guint32. |

Since: 1.28

### MbimProvisionedContextElementV2Array

    typedef MbimProvisionedContextElementV2 *MbimProvisionedContextElementV2Array;

A NULL-terminated array of MbimProvisionedContextElementV2 elements.

Since: 1.28

### MbimCellInfoServingGsm

    typedef struct {
        gchar *provider_id;
        guint32 location_area_code;
        guint32 cell_id;
        guint32 timing_advance;
        guint32 arfcn;
        guint32 base_station_id;
        guint32 rx_level;
    } MbimCellInfoServingGsm;

A MbimCellInfoServingGsm element.

#### Members

gchar *`provider_id`; | a string. |
guint32 `location_area_code`; | a guint32. |
guint32 `cell_id`; | a guint32. |
guint32 `timing_advance`; | a guint32. |
guint32 `arfcn`; | a guint32. |
guint32 `base_station_id`; | a guint32. |
guint32 `rx_level`; | a guint32. |

Since: 1.28

### MbimCellInfoServingUmts

    typedef struct {
        gchar *provider_id;
        guint32 location_area_code;
        guint32 cell_id;
        guint32 frequency_info_ul;
        guint32 frequency_info_dl;
        guint32 frequency_info_nt;
        guint32 uarfcn;
        guint32 primary_scrambling_code;
        gint32 rscp;
        gint32 ecno;
        guint32 path_loss;
    } MbimCellInfoServingUmts;

A MbimCellInfoServingUmts element.

#### Members

gchar *`provider_id`; | a string. |
guint32 `location_area_code`; | a guint32. |
guint32 `cell_id`; | a guint32. |
guint32 `frequency_info_ul`; | a guint32. |
guint32 `frequency_info_dl`; | a guint32. |
guint32 `frequency_info_nt`; | a guint32. |
guint32 `uarfcn`; | a guint32. |
guint32 `primary_scrambling_code`; | a guint32. |
gint32 `rscp`; | a gint32. |
gint32 `ecno`; | a gint32. |
guint32 `path_loss`; | a guint32. |

Since: 1.28

### MbimCellInfoServingTdscdma

    typedef struct {
        gchar *provider_id;
        guint32 location_area_code;
        guint32 cell_id;
        guint32 uarfcn;
        guint32 cell_parameter_id;
        guint32 timing_advance;
        gint32 rscp;
        guint32 path_loss;
    } MbimCellInfoServingTdscdma;

A MbimCellInfoServingTdscdma element.

#### Members

gchar *`provider_id`; | a string. |
guint32 `location_area_code`; | a guint32. |
guint32 `cell_id`; | a guint32. |
guint32 `uarfcn`; | a guint32. |
guint32 `cell_parameter_id`; | a guint32. |
guint32 `timing_advance`; | a guint32. |
gint32 `rscp`; | a gint32. |
guint32 `path_loss`; | a guint32. |

Since: 1.28

### MbimCellInfoServingLte

    typedef struct {
        gchar *provider_id;
        guint32 cell_id;
        guint32 earfcn;
        guint32 physical_cell_id;
        guint32 tac;
        gint32 rsrp;
        gint32 rsrq;
        guint32 timing_advance;
    } MbimCellInfoServingLte;

A MbimCellInfoServingLte element.

#### Members

gchar *`provider_id`; | a string. |
guint32 `cell_id`; | a guint32. |
guint32 `earfcn`; | a guint32. |
guint32 `physical_cell_id`; | a guint32. |
guint32 `tac`; | a guint32. |
gint32 `rsrp`; | a gint32. |
gint32 `rsrq`; | a gint32. |
guint32 `timing_advance`; | a guint32. |

Since: 1.28

### MbimCellInfoNeighboringGsm

    typedef struct {
        gchar *provider_id;
        guint32 location_area_code;
        guint32 cell_id;
        guint32 arfcn;
        guint32 base_station_id;
        guint32 rx_level;
    } MbimCellInfoNeighboringGsm;

A MbimCellInfoNeighboringGsm element.

#### Members

gchar *`provider_id`; | a string. |
guint32 `location_area_code`; | a guint32. |
guint32 `cell_id`; | a guint32. |
guint32 `arfcn`; | a guint32. |
guint32 `base_station_id`; | a guint32. |
guint32 `rx_level`; | a guint32. |

Since: 1.28

### MbimCellInfoNeighboringGsmArray

    typedef MbimCellInfoNeighboringGsm *MbimCellInfoNeighboringGsmArray;

A NULL-terminated array of MbimCellInfoNeighboringGsm elements.

Since: 1.28

### MbimCellInfoNeighboringUmts

    typedef struct {
        gchar *provider_id;
        guint32 location_area_code;
        guint32 cell_id;
        guint32 uarfcn;
        guint32 primary_scrambling_code;
        gint32 rscp;
        gint32 ecno;
        guint32 path_loss;
    } MbimCellInfoNeighboringUmts;

A MbimCellInfoNeighboringUmts element.

#### Members

gchar *`provider_id`; | a string. |
guint32 `location_area_code`; | a guint32. |
guint32 `cell_id`; | a guint32. |
guint32 `uarfcn`; | a guint32. |
guint32 `primary_scrambling_code`; | a guint32. |
gint32 `rscp`; | a gint32. |
gint32 `ecno`; | a gint32. |
guint32 `path_loss`; | a guint32. |

Since: 1.28

### MbimCellInfoNeighboringUmtsArray

    typedef MbimCellInfoNeighboringUmts *MbimCellInfoNeighboringUmtsArray;

A NULL-terminated array of MbimCellInfoNeighboringUmts elements.

Since: 1.28

### MbimCellInfoNeighboringTdscdma

    typedef struct {
        gchar *provider_id;
        guint32 location_area_code;
        guint32 cell_id;
        guint32 uarfcn;
        guint32 cell_parameter_id;
        guint32 timing_advance;
        gint32 rscp;
        guint32 path_loss;
    } MbimCellInfoNeighboringTdscdma;

A MbimCellInfoNeighboringTdscdma element.

#### Members

gchar *`provider_id`; | a string. |
guint32 `location_area_code`; | a guint32. |
guint32 `cell_id`; | a guint32. |
guint32 `uarfcn`; | a guint32. |
guint32 `cell_parameter_id`; | a guint32. |
guint32 `timing_advance`; | a guint32. |
gint32 `rscp`; | a gint32. |
guint32 `path_loss`; | a guint32. |

Since: 1.28

### MbimCellInfoNeighboringTdscdmaArray

    typedef MbimCellInfoNeighboringTdscdma *MbimCellInfoNeighboringTdscdmaArray;

A NULL-terminated array of MbimCellInfoNeighboringTdscdma elements.

Since: 1.28

### MbimCellInfoNeighboringLte

    typedef struct {
        gchar *provider_id;
        guint32 cell_id;
        guint32 earfcn;
        guint32 physical_cell_id;
        guint32 tac;
        gint32 rsrp;
        gint32 rsrq;
    } MbimCellInfoNeighboringLte;

A MbimCellInfoNeighboringLte element.

#### Members

gchar *`provider_id`; | a string. |
guint32 `cell_id`; | a guint32. |
guint32 `earfcn`; | a guint32. |
guint32 `physical_cell_id`; | a guint32. |
guint32 `tac`; | a guint32. |
gint32 `rsrp`; | a gint32. |
gint32 `rsrq`; | a gint32. |

Since: 1.28

### MbimCellInfoNeighboringLteArray

    typedef MbimCellInfoNeighboringLte *MbimCellInfoNeighboringLteArray;

A NULL-terminated array of MbimCellInfoNeighboringLte elements.

Since: 1.28

### MbimCellInfoCdma

    typedef struct {
        guint32 serving_cell_flag;
        guint32 nid;
        guint32 sid;
        guint32 base_station_id;
        guint32 base_latitude;
        guint32 base_longitude;
        guint32 ref_pn;
        guint32 gps_seconds;
        guint32 pilot_strength;
    } MbimCellInfoCdma;

A MbimCellInfoCdma element.

#### Members

guint32 `serving_cell_flag`; | a guint32. |
guint32 `nid`; | a guint32. |
guint32 `sid`; | a guint32. |
guint32 `base_station_id`; | a guint32. |
guint32 `base_latitude`; | a guint32. |
guint32 `base_longitude`; | a guint32. |
guint32 `ref_pn`; | a guint32. |
guint32 `gps_seconds`; | a guint32. |
guint32 `pilot_strength`; | a guint32. |

Since: 1.28

### MbimCellInfoCdmaArray

    typedef MbimCellInfoCdma *MbimCellInfoCdmaArray;

A NULL-terminated array of MbimCellInfoCdma elements.

Since: 1.28